/**
    Constants
*/

var DEVICE_TYPE_PHONE = "phone";
var DEVICE_TYPE_SMALL_TABLET = "small-tablet";
var DEVICE_TYPE_LARGE_TABLET = "large-tablet";

var DEVICE_SIZE_PHONE = "phone";
var DEVICE_SIZE_TABLET = "tablet";

var TABOOLA_MID_CONTAINER = "taboola-mid-article-Android";
var TABOOLA_MID_MODE = "thumbnails-c";
var TABOOLA_MID_PLACEMENT = "Mid Article Thumbnail";

var TABOOLA_MODE_PHONE = "thumbnails-b";
var TABOOLA_MODE_TABLET = "thumbnails-b";
var TABOOLA_CONTAINER_PHONE = "taboola-app-article-Android-smartphone";
var TABOOLA_CONTAINER_TABLET = "taboola-app-article-Android-tablet";
var TABOOLA_PLACEMENT_PHONE = "app-article-Android-smartphone";
var TABOOLA_PLACEMENT_TABLET = "app-article-Android-tablet";

/**
    Control flags
*/
var didLoadTaboolaAds = false;

/**
    Getters
*/
function getTaboolaMode() {
  var mode;
  if (size == DEVICE_SIZE_PHONE) {
    mode = TABOOLA_MODE_PHONE;
  } else {
    mode = TABOOLA_MODE_TABLET;
  }

  return mode;
}

function getTaboolaMidMode() {
  return TABOOLA_MID_MODE;
}

function getTaboolaContainer() {
  var container;
  if (size == DEVICE_SIZE_PHONE) {
    container = TABOOLA_CONTAINER_PHONE;
  } else {
    container = TABOOLA_CONTAINER_TABLET;
  }

  return container;
}

function getTaboolaMidContainer() {
  return TABOOLA_MID_CONTAINER;
}

function getTaboolaPlacement() {
  var placement;
  if (size == DEVICE_SIZE_PHONE) {
    placement = TABOOLA_PLACEMENT_PHONE;
  } else {
    placement = TABOOLA_PLACEMENT_TABLET;
  }

  return placement;
}

function getTaboolaMidPlacement() {
  return TABOOLA_MID_PLACEMENT;
}

/**
    Hide native loading
*/
function hideAndroidLoading() {
    Android.hideLoading();
}

/** 
   Init Taboola
*/
function initTaboola() {
  window._taboola = window._taboola || [];
  _taboola.push({article:'auto'});

  !function (e, f, u) {
    e.async = 1;
    e.src = u;
    f.parentNode.insertBefore(e, f);
  }(document.createElement('script'),
  document.getElementsByTagName('script')[0],
  'https://cdn.taboola.com/libtrc/merriamwebster-androidapp/loader.js');
}

/**
   Place Taboola
*/
function placeTaboola() {
  var taboolaDivs =
  $("div *").filter(function() {return(this.id == getTaboolaContainer());}).length

  if (taboolaDivs == 0) {
    $('#definition').append('<div id="'+ getTaboolaContainer() +'"/>');

    var defs = $("#definition .def");
    if (defs.length > 1) {
      $(defs[0]).after('<div id="'+ getTaboolaMidContainer() +'"/>');
    }
  }
}

/** 
   Load Taboola
*/
function loadTaboola() {
   window._taboola = window._taboola || [];

   _taboola.push({
       mode: getTaboolaMode(),
       container: getTaboolaContainer(),
       placement: getTaboolaPlacement(),
       target_type: 'mix'
     });

   _taboola.push({
       mode: getTaboolaMidMode(),
       container: getTaboolaMidContainer(),
       placement: getTaboolaMidPlacement(),
       target_type: 'mix'
     });
}

/**
    Flush Taboola
*/
function flushTaboola() {
  window._taboola = window._taboola || [];
  _taboola.push({flush: true});
}

/**
 Show Taboola Ads
 */
function showTaboolaAds() {
  if (!didLoadTaboolaAds) {
    didLoadTaboolaAds = true;
    
    initTaboola();
    placeTaboola();
    loadTaboola();
    flushTaboola();
  } 
}